(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)







BeginPackage["MCUtilities`",{"SafeMathProg`"}];

Off[General::"spell"];



(* Internal Needs *)



(Begin["MCUtilities`"];)

removeSemiColon;              (* remove semicolon in mixed ,
								and ; decl list *)
findContextOf;                (* Find context of symbol or head of
								 symbol *)
ultimateHead;                 (* Take head of head etc. until a
								 symbol *)
contextToString; (* Convert expr to string with context
								 prefixes explicit *)
Interleave;		(* Interleaves an expression in between
							arguments *)
ExistFileQ;		(* Checks if a file exists in current directory *)

AddSuffix;		(* Adds file name suffix *)
AddOneSuffix;
AddExtension;	(* Adds a file extenstion if missing *)

MyToString; MyToStringForce; (* Yet another context functions *)

AddFullPath;	(* Adds fullpath to filenames relative a reference file *)
FullPathQ; (* True if the path is relative to root *)

ToStringContextFree; (* The hope in the land of contexts, JG *)

ReplaceAllAtLevel;	(* ReplaceAll at a specific level in an expr. *)

End[];



(Begin["MCUtilitites`Private`"];)

End[];







(* removeSemiColon -    remove ; in list of mixed comma and semicolon *)

BeginFunction[removeSemiColon];

removeSemiColon::usage = "
removeSemiColon[Hold[decls]] removes semicolon as separator in a mixed ; and ,
list. Also removes Null declarations ; \n
Example: removeSemiColon[Hold[a;b,d;]] returns Hold[a,b,d]
";

(* Case example:  Hold[a;b,d;] *)

removeSemiColon[Hold[]] := Hold[];

removeSemiColon[Hold[decls___]] := 
  DeleteCases[Flatten[Hold[decls],2,CompoundExpression],Null];
  
EndFunction[]; (* removeSemiColon *)










(* findContextOf *)

BeginFunction[findContextOf];

findContextOf::usage = 
"findContextOf[headexpr] finds the \
context  prefix of the headsymbol of headexpr. \n \
findContextOf is HoldAll. \n
  Examples:  \
findContextOf[func],  findContextOf[f[a][b][x_]] ";

Attributes[findContextOf] = {HoldAll};

(*
	??WHY is String exepted as argument? JG
	An Unevaluated must be added inside Context to prevent
	f to evaluate *)
(*
findContextOf[(f_Symbol) | (f_String)] := Context[f];
*)
(* New version *)
findContextOf[(f_Symbol)] := Context[Unevaluated[f]];

findContextOf[(f_)[args___]] := findContextOf[f];

EndFunction[];







(* ultimateHead *)

(* ultimateHead - find the ultimate head of an (indexed) function head *)

BeginFunction[ultimateHead]
 
ultimateHead::usage = 
"ultimateHead[Hold[headexpr]] finds the ultimate head of a
head expression. \n
Examples:  ultimateHead[Hold[f[x_]]] returns Hold[f] \n
ultimateHead[Hold[f[a][b][x_]]] returns Hold[f] \n
ultimateHead[Hold[f]]  just returns Hold[f] ";

ultimateHead[Hold[f_[args___]]] := ultimateHead[Hold[f]];

ultimateHead[Hold[f_Symbol]] := Hold[f];

EndFunction[];













BeginFunction[contextToString]

contextToString[expr_] := Module[{
  ContextPathSave = $ContextPath,
  result
 },
  $ContextPath = {"MathCode`","ObjectMath`","ObjectMathConv`","System`"};
  result = ToString[expr];
  $ContextPath = ContextPathSave;
  result
];

EndFunction[];







BeginFunction[Interleave]

Interleave::usage=
  "Interleave[{e1,e2,e3,...,en},x] inserts x in between the elements in the \
list. The result is then {e1,x,e2,x,e3,x,...,en}. The list can have any head \
not necessarily List.";
		
Interleave[expr_,element_] :=
	Insert[expr, element, Thread[{Range[Length[expr]-1]+1}]];
	
EndFunction[];

















BeginFunction[ExistFileQ];

ExistFileQ::usage = "ExistFileQ[\"PACKAGE.nb\"] checks whether the code of the notebook is present in the current directory. If not you should change to the correct directory. You should use this check before any writing or reading from files is done. Typically it is before CompilePackage[].";

ExistFileQ[packageName_String]:=
  If[ FileNames[packageName,Directory[]]=={},
     Message[ExistFileQ::failed,
     	Directory[] <> $PathnameSeparator <> packageName];
     	Abort[]
    ];

EndFunction[];



BeginFunction[AddOneSuffix, AddSuffix, AddExtension];

AddOneSuffix[fname_,suffix_]:=
  If[StringPosition[StringDrop[fname ,
       StringLength[DirectoryName[fname]]], "."]
    ==={},
    fname <> suffix<> " " ,
    fname<> " " ];
(* Add suffix if there is no suffix in file name. Always adds a space. *)


AddSuffix[flist_, suffix_]:=
  Map[AddOneSuffix[#,suffix] &,flist];
  
AddExtension[fname_String, suffix_String]:=
  If[StringPosition[StringDrop[fname ,
       StringLength[DirectoryName[fname]]], "."]
    ==={},
    fname <> suffix ,
    fname ];

EndFunction[];



(* JG added temporarily change to $Context also. This makes
   CompilePackage["Global"] work. 971015 *)

BeginFunction[MyToString, MyToStringForce];

MyToString[expr_] := 
  Module[ { ContextPathSave = $ContextPath, ContextSave=$Context, result },
	If[ReleaseHold[ findContextOf /@ expr] =!= "System`",
	          $ContextPath = { "System`" };
		  $Context = "System`";
         	 result = ToString[expr];
	 	 $ContextPath = ContextPathSave;
	 	 $Context = ContextSave;
         	 result
	,
	   "Hold[System`"<> ReleaseHold[SymbolName /@ expr]<>"]"
 ]
];

(* How the context name can be replaced in the function
   qualified name (string) *)
MyToStringForce[expr_,context_String]:=
    Module [ {result,k,res},
          result = MyToString[expr];
	  (*Contains Hold[Pack`Func] -> Hold[OtherPack`Func] *)
          k = StringPosition[result,"`"][[1]][[1]];
          res = "Hold[" <> context <> "`" <> 
          		StringDrop[result,k];
          res
    ];
           
EndFunction[];





(* Used to be BeginFunction[RootPathQ] but that can't be correct can it?
   Pontus 981105 *)
BeginFunction[FullPathQ];

FullPathQ::usage = "FullPathQ[path] returns true if path is a full path, i.e. if it starts with / or \\ or a DOS drive specification.";

FullPathQ[path_String] := (
	StringMatchQ[path, "/*"] || StringTake[path,1]=== "\\" ||
	StringTake[path,{2,2}]===":");

EndFunction[]



















BeginFunction[AddFullPath];

AddFullPath[filename_String, reffile_String] := Module[
	{refpath, fileset},
	
	(* Finds the path in wich reffile can be found. *)
	fileset = FileNames[reffile,$Path];
	If[ Length[fileset]>0,
		refpath = DirectoryName@ First@ fileset
	,
		Return[filename]
	];
	
	(* Add refpath to all filenames in list which is not
	   fullpath *)
	   
	If[FullPathQ[filename], 
		filename
	,
		refpath<>filename
	]
];

AddFullPath[filenames_List, reffile_String] :=
	AddFullPath[#, reffile]& /@ filenames;
	
EndFunction[];			



















BeginFunction[ToStringContextFree];

ToStringContextFree::usage = "ToStringContextFree[expr] converts the expression expr to a string like ToString except that no context prefix are included. ToStringContextFree[a`f[b`x_, c`y_]] will return \"f[x_,y_]\".";

(*
ToStringContextFree[expr_] := Module[{cntx},
   	cntx = Union@ 
		Cases[expr,
			x_Symbol :> 
			Context[x],
			Infinity,
			Heads->True];
	Block[{$ContextPath = cntx},
	     System`Print["ToStringContextFree=",System`ToString[expr]];
	     System`ToString[expr]
	]
];
*)
ToStringContextFree[expr_]:=
    Module[
      {d,charConstPositions,prefixPositions,theCon,bracketPositions,charConstPositions2},
      d=ToString[expr];
      
      (* character string constants must be ignored in this filter *) 
      charConstPositions=
        StringPosition[d,"\""~~Except["\""]...~~"\"",Overlaps->False] ;
      (* Prefix must be an identifier *)
      
      prefixPositions=
        StringPosition[d,LetterCharacter~~WordCharacter..~~"`",
          Overlaps->False] ;
      (* Remove those prefix positions that occured within *)
      (* constant character strings; use interval arithmeics *)
      
      Scan[(theCon=#;
            prefixPositions=Select
                [
                prefixPositions,
                ( 
                      
                     (* Print[ theCon[[1]]," ",#[[1]]  ," ",  #[[2]]," ", 
                          theCon[[2]], 
                          theCon[[1]]<#[[1]]   ,  #[[2]]< 
                            theCon[[2]]]; *)
                      
                    Not[ theCon[[1]]<#[[1]]   &&  #[[2]]< theCon[[2]]   ])&
                ]
            )&,
        charConstPositions];
      
      
      
      
      
     
      d=StringReplacePart[d,"",prefixPositions];
      
       charConstPositions2=
        StringPosition[d,"\""~~Except["\""]...~~"\"",Overlaps->False] ;
        
     bracketPositions=
        StringPosition[d,"]",  Overlaps->False] ;
         
     
     Scan[(theCon=#;
            bracketPositions=Select
                [
                bracketPositions,
                ( 
                      
                     (* Print[ theCon[[1]]," ",#[[1]]  ," ",  #[[2]]," ", 
                          theCon[[2]], 
                          theCon[[1]]<#[[1]]   ,  #[[2]]< 
                            theCon[[2]]]; *)
                      
                    Not[ theCon[[1]]<#[[1]]   &&  #[[2]]< theCon[[2]]   ])&
                ]
            )&,
        charConstPositions2];
     
     d=StringReplacePart[d,"]\n",bracketPositions];
     
      d
      ];

EndFunction[];





BeginFunction[ReplaceAllAtLevel];

ReplaceAllAtLevel::usage="ReplaceAllAtLevel[expr, rules, level] works as ReplaceAll but the rules are only applied at level in expr.";

ReplaceAllAtLevel[expr_, {}, _] := expr;

ReplaceAllAtLevel[expr_, patt:(_Rule|_RuleDelayed), l_] := 
	ReplaceAllAtLevel[expr, {patt}, l];

ReplaceAllAtLevel[expr_,
 patt:{(_Rule|_RuleDelayed)..},
 l_Integer] := Module[{MARKER},
	(
	(* Puts MARKER at all parts at level *)
	Map[MARKER, expr, {l}] /.
	(* Puts MARKER around the patterns *)
	MapAt[MARKER, patt,
		Thread[{Range[Length[patt]],1}]]
	) //.
	(* Remove MARKER that are left *)
	MARKER[x___]:> x
];

EndFunction[];

































On[General::"spell"];
(* Close the package *)
EndPackage[];