#include "system.h"

#include "system.icc"

#include <math.h>
double system_TErf ( const double &x)
{
    return ( (-2. <= x && x <= 2.) ? (system_TErfOne (x)) : ( (x > 2.) ? (
        system_TErfTwo (x)) : ( (x < -2.) ? (-system_TErfTwo (-x)) :  ( -
        system_TErfTwo (-x) ) )));
}

lm_complexN system_TFourier ( const lm_complexN &aff)
{
    return system_TFourier3 (aff, 0, 1);
}

lm_complexN system_TFourier3 ( const lm_complexN &u, const int &af, const int &b
    )
{
    int n;
    lm_complex summ = 0;
    lm_complexN v(0);
    v = u;
    int r;
    int s;
    int r_D1759;
    int s_D1762;

    n = u.dimension(1);
    s_D1762 = 1;
    while (s_D1762 <= n)
    {
        summ = 0;
        r_D1759 = 1;
        while (r_D1759 <= n)
        {
            summ = summ+u(r_D1759)*exp(2.*3.14159265358979323846*lm_complex(0,1)
                *(b*1.)*(r_D1759+-1.)*((s_D1762+-1.)/(n*1.)));
            r_D1759 = r_D1759+1;
        }
        v(s_D1762) = summ;
        s_D1762 = s_D1762+1;
    }
    return v*(1./pow(n*1., (1.+-af)/2.));
}

lm_complexN system_TInverseFourier ( const lm_complexN &bff)
{
    return system_TInverseFourier3 (bff, 0, 1);
}

lm_complexN system_TInverseFourier3 ( const lm_complexN &v, const int &af, 
    const int &b)
{
    int n;
    lm_complex summ = 0;
    lm_complexN u(0);
    u = v;
    int r;
    int s;
    int s_D1876;
    int r_D1879;

    n = v.dimension(1);
    r_D1879 = 1;
    while (r_D1879 <= n)
    {
        summ = 0;
        s_D1876 = 1;
        while (s_D1876 <= n)
        {
            summ = summ+v(s_D1876)*exp(-2.*3.14159265358979323846*
                lm_complex(0,1)*(b*1.)*(r_D1879+-1.)*((s_D1876+-1.)/(n*1.)));
            s_D1876 = s_D1876+1;
        }
        u(r_D1879) = summ;
        r_D1879 = r_D1879+1;
    }
    return u*(1./pow(n*1., (1.+af)/2.));
}

intN system_TRotateLeft ( const intN &ar)
{
    int m = ar.dimension(1);
    intN res(m);

    res.Set(R(1,m+-1),ar(R(2,m)));
    res(m) = ar(1);
    return res;
}

intN system_TRotateRight ( const intN &ar)
{
    int m = ar.dimension(1);
    intN res(m);

    res.Set(R(2,m),ar(R(1,m+-1)));
    res(1) = ar(m);
    return res;
}

void system_TsystemInit ()
{
; 
}

double system_TErfOne ( const double &x)
{
    double mc_T1;
    double mc_T2;
    double mc_T3;
    double mc_T4;
    double mc_T5;
    double mc_T6;
    double mc_T7;
    double mc_T8;
    double mc_T9;
    double mc_T10;
    double mc_T11;
    double mc_T12;
    double mc_T13;
    double mc_T14;
    double mc_T15;
    double mc_T16;
    double mc_T17;
    double mc_T18;
    double mc_T19;
    double mc_T20;
    double mc_T21;
    double mc_T22;
    double mc_T23;
    double mc_T24;
    double mc_T25;
    double mc_T26;
    double mc_T27;
    double mc_T28;
    double mc_T29;
    double mc_T30;
    double mc_T31;
    double mc_T32;
    double mc_T33;
    double mc_T34;
    double mc_T35;
    double mc_T36;
    double mc_T37;
    double mc_T38;
    double mc_T39;
    double mc_T40;
    double mc_T41;
    double mc_T42;
    double mc_T43;
    double mc_T44;
    double mc_T45;
    double mc_T46;
    double mc_T47;
    double mc_T48;
    double mc_T49;
    double mc_T50;
    double mc_T51;
    double mc_T52;
    double mc_T53;
    double mc_T54;
    double mc_T55;
    double mc_T56;
    double mc_T57;
    double mc_T58;
    double mc_T59;
    double mc_T60;
    double mc_T61;
    double mc_T62;
    double mc_T63;
    double mc_T64;
    mc_T1 = (x*x);
    mc_T2 = 40.*mc_T1;
    mc_T3 = 39.+mc_T2;
    mc_T4 = -38.*mc_T1;
    mc_T5 = mc_T4/mc_T3;
    mc_T6 = 37.+mc_T5;
    mc_T7 = 36.*mc_T1;
    mc_T8 = mc_T7/mc_T6;
    mc_T9 = 35.+mc_T8;
    mc_T10 = -34.*mc_T1;
    mc_T11 = mc_T10/mc_T9;
    mc_T12 = 33.+mc_T11;
    mc_T13 = 32.*mc_T1;
    mc_T14 = mc_T13/mc_T12;
    mc_T15 = 31.+mc_T14;
    mc_T16 = -30.*mc_T1;
    mc_T17 = mc_T16/mc_T15;
    mc_T18 = 29.+mc_T17;
    mc_T19 = 28.*mc_T1;
    mc_T20 = mc_T19/mc_T18;
    mc_T21 = 27.+mc_T20;
    mc_T22 = -26.*mc_T1;
    mc_T23 = mc_T22/mc_T21;
    mc_T24 = 25.+mc_T23;
    mc_T25 = 24.*mc_T1;
    mc_T26 = mc_T25/mc_T24;
    mc_T27 = 23.+mc_T26;
    mc_T28 = -22.*mc_T1;
    mc_T29 = mc_T28/mc_T27;
    mc_T30 = 21.+mc_T29;
    mc_T31 = 20.*mc_T1;
    mc_T32 = mc_T31/mc_T30;
    mc_T33 = 19.+mc_T32;
    mc_T34 = -18.*mc_T1;
    mc_T35 = mc_T34/mc_T33;
    mc_T36 = 17.+mc_T35;
    mc_T37 = 16.*mc_T1;
    mc_T38 = mc_T37/mc_T36;
    mc_T39 = 15.+mc_T38;
    mc_T40 = -14.*mc_T1;
    mc_T41 = mc_T40/mc_T39;
    mc_T42 = 13.+mc_T41;
    mc_T43 = 12.*mc_T1;
    mc_T44 = mc_T43/mc_T42;
    mc_T45 = 11.+mc_T44;
    mc_T46 = -10.*mc_T1;
    mc_T47 = mc_T46/mc_T45;
    mc_T48 = 9.+mc_T47;
    mc_T49 = 8.*mc_T1;
    mc_T50 = mc_T49/mc_T48;
    mc_T51 = 7.+mc_T50;
    mc_T52 = -6.*mc_T1;
    mc_T53 = mc_T52/mc_T51;
    mc_T54 = 5.+mc_T53;
    mc_T55 = 4.*mc_T1;
    mc_T56 = mc_T55/mc_T54;
    mc_T57 = 3.+mc_T56;
    mc_T58 = -2.*mc_T1;
    mc_T59 = mc_T58/mc_T57;
    mc_T60 = 1.+mc_T59;
    mc_T61 = -1.*mc_T1;
    mc_T62 = pow(2.718281828459045, mc_T61);
    mc_T63 = 1.1283791670955126*mc_T62*x;
    mc_T64 = mc_T63/mc_T60;
    return mc_T64;
}

double system_TErfTwo ( const double &x)
{
    double mc_T1;
    double mc_T2;
    double mc_T3;
    double mc_T4;
    double mc_T5;
    double mc_T6;
    double mc_T7;
    double mc_T8;
    double mc_T9;
    double mc_T10;
    double mc_T11;
    double mc_T12;
    double mc_T13;
    double mc_T14;
    double mc_T15;
    double mc_T16;
    double mc_T17;
    double mc_T18;
    double mc_T19;
    double mc_T20;
    double mc_T21;
    double mc_T22;
    double mc_T23;
    double mc_T24;
    double mc_T25;
    double mc_T26;
    double mc_T27;
    double mc_T28;
    double mc_T29;
    double mc_T30;
    double mc_T31;
    double mc_T32;
    double mc_T33;
    double mc_T34;
    double mc_T35;
    double mc_T36;
    double mc_T37;
    double mc_T38;
    double mc_T39;
    double mc_T40;
    double mc_T41;
    double mc_T42;
    double mc_T43;
    double mc_T44;
    double mc_T45;
    double mc_T46;
    mc_T1 = 1.4142135623730951*x;
    mc_T2 = 20.+mc_T1;
    mc_T3 = 19./mc_T2;
    mc_T4 = mc_T1+mc_T3;
    mc_T5 = 18./mc_T4;
    mc_T6 = mc_T1+mc_T5;
    mc_T7 = 17./mc_T6;
    mc_T8 = mc_T1+mc_T7;
    mc_T9 = 16./mc_T8;
    mc_T10 = mc_T1+mc_T9;
    mc_T11 = 15./mc_T10;
    mc_T12 = mc_T1+mc_T11;
    mc_T13 = 14./mc_T12;
    mc_T14 = mc_T1+mc_T13;
    mc_T15 = 13./mc_T14;
    mc_T16 = mc_T1+mc_T15;
    mc_T17 = 12./mc_T16;
    mc_T18 = mc_T1+mc_T17;
    mc_T19 = 11./mc_T18;
    mc_T20 = mc_T1+mc_T19;
    mc_T21 = 10./mc_T20;
    mc_T22 = mc_T1+mc_T21;
    mc_T23 = 9./mc_T22;
    mc_T24 = mc_T1+mc_T23;
    mc_T25 = 8./mc_T24;
    mc_T26 = mc_T1+mc_T25;
    mc_T27 = 7./mc_T26;
    mc_T28 = mc_T1+mc_T27;
    mc_T29 = 6./mc_T28;
    mc_T30 = mc_T1+mc_T29;
    mc_T31 = 5./mc_T30;
    mc_T32 = mc_T1+mc_T31;
    mc_T33 = 4./mc_T32;
    mc_T34 = mc_T1+mc_T33;
    mc_T35 = 3./mc_T34;
    mc_T36 = mc_T1+mc_T35;
    mc_T37 = 2./mc_T36;
    mc_T38 = mc_T1+mc_T37;
    mc_T39 = 1/mc_T38;
    mc_T40 = mc_T1+mc_T39;
    mc_T41 = (x*x);
    mc_T42 = -1.*mc_T41;
    mc_T43 = pow(2.718281828459045, mc_T42);
    mc_T44 = -0.7978845608028654*mc_T43;
    mc_T45 = mc_T44/mc_T40;
    mc_T46 = 1.+mc_T45;
    return mc_T46;
}

